hdr;


%  load c.xy;    p=c; load c.pts;   t=c;
%  load a.xy;    p=a; load a.pts;   t=a;
load pts.dat;    p=pts; load tri.dat;  t=tri;

E =size(t,1);
nv=size(t,2);
nL=E*nv;
nb=size(p,1);  %%% THIS MAY BE AN OVERESTIMATE
tmp=zeros(nb,1);
tmp(reshape(t,3*E,1))=1;
nb=sum(tmp);

[AL,BL,Q]=local_fem_mats(p,t);
[maskL,gbdry] = get_maskl(t);
nbdry = size(gbdry,1);
rbdry = sqrt(p(gbdry,1).^2+p(gbdry,2).^2);
ibbox = find(rbdry > 0.41);
ibbox = find(rbdry < 0.41);
dbdry = gbdry(ibbox);
gbdry = dbdry;

%%% Set up restriction/permutation matrix to make boundary nodes last

ir=[1:nb]';

n = nb-size(gbdry,1);
ir(gbdry) = ir(gbdry) + 2*nb;
[is,ind]=sort(ir); ind=ind(1:n);
P=speye(nb); P=P(:,ind); R=P';

%%%% Plot a function that is 1 in the interior, 0 on the boundary.

f=ones(n,1);   %% 1 in Interior
fb=R'*f;       %% Extend by 0 to the boundary.

hold off; tri=trimesh(t,p(:,1),p(:,2),fb);          %% Surface Plot
hold on;  plot(p(gbdry,1),p(gbdry,2),'r.',ms,9);    %% Plot boundary nodes in red.
axis equal; 
pause(1)


%%% Solve a PDE: -nabla^2 u = f(x,y), with f = y/x

rad = sqrt(p(:,1).^2+p(:,2).^2);
rad = rad(reshape(t,3*E,1));   %% Here, a continuous function of x and y
fL  = sin(5*pi*rad);                                   %% Here, a continuous function of x and y
fe=reshape(fL,E,3);
fe=fe';
fL=reshape(fe,3*E,1);
fL=.2+fL*5;

Ab = Q'*AL*Q; A = R*Ab*R';
Bb = Q'*BL*Q; B = R*Bb*R';


u  = A \ (R*(Q'*(BL*fL))); ue=u;
ub = R'*u;
hold off; tri=trimesh(t,p(:,1),p(:,2),ub);          %% Surface Plot
hold on;  plot(p(gbdry,1),p(gbdry,2),'r.',ms,9);    %% Plot boundary nodes in red.
axis equal; 

pause

%%%% Solve using Jacobi Iteration

D=diag(A); Di=1./D;

u = 0*u;
b = R*(Q'*(BL*fL));
for k=1:50;

 u = u + Di.*(b-A*u);

 eb = R'*(u-1.0*ue); err=max(abs(eb)); eb=abs(eb)/err;
 hold off; tri=trimesh(t,p(:,1),p(:,2),eb);          %% Surface Plot
 hold on;  plot(p(gbdry,1),p(gbdry,2),'r.',ms,9);    %% Plot boundary nodes in red.
 axis equal; 
 title(['Error/Soln, Iter: ' int2str(k) ', Error: ',num2str(err)],fs,18);
 xlabel('X',fs,18); ylabel('Y',fs,18); pause(.1);

end;


